/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 * Apache Antタスク [BlancoXliffUtilExtractNeedsTranslation]のクラス
 */
package blanco.xliff.util.task;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import blanco.xliff.util.task.valueobject.BlancoXliffUtilExtractNeedsTranslationProcessInput;

/**
 * Apache Antタスク [BlancoXliffUtilExtractNeedsTranslation]のクラス。
 *
 * [XLIFF対応ツール] 翻訳が必要な trans-unit を抽出します。translate=&quot;no&quot; の trans-unit はスキップします。また、内容が重複すると判断されたものについて抽出を集約します。<br>
 * このクラスでは、Apache Antタスクで一般的に必要なチェックなどのコーディングを肩代わりします。
 * 実際の処理は パッケージ[blanco.xliff.util.task]にBlancoXliffUtilExtractNeedsTranslationBatchProcessクラスを作成して記述してください。<br>
 * <br>
 * Antタスクへの組み込み例<br>
 * <pre>
 * &lt;taskdef name=&quot;blancoxliffutilextractneedstranslation&quot; classname=&quot;blanco.xliff.util.task.BlancoXliffUtilExtractNeedsTranslationTask">
 *     &lt;classpath&gt;
 *         &lt;fileset dir=&quot;lib&quot; includes=&quot;*.jar&quot; /&gt;
 *         &lt;fileset dir=&quot;lib.ant&quot; includes=&quot;*.jar&quot; /&gt;
 *     &lt;/classpath&gt;
 * &lt;/taskdef&gt;
 * </pre>
 */
public class BlancoXliffUtilExtractNeedsTranslationTask extends Task {
    /**
     * [XLIFF対応ツール] 翻訳が必要な trans-unit を抽出します。translate=&quot;no&quot; の trans-unit はスキップします。また、内容が重複すると判断されたものについて抽出を集約します。
     */
    protected BlancoXliffUtilExtractNeedsTranslationProcessInput fInput = new BlancoXliffUtilExtractNeedsTranslationProcessInput();

    /**
     * [XLIFF対応ツール] 翻訳が必要な trans-unit を抽出します。translate=&quot;no&quot; の trans-unit はスキップします。また、内容が重複すると判断されたものについて抽出を集約します。
     */
    protected boolean fIsFieldTargetfileProcessed = false;

    /**
     * [XLIFF対応ツール] 翻訳が必要な trans-unit を抽出します。translate=&quot;no&quot; の trans-unit はスキップします。また、内容が重複すると判断されたものについて抽出を集約します。
     */
    protected boolean fIsFieldXliffdirProcessed = false;

    /**
     * [XLIFF対応ツール] 翻訳が必要な trans-unit を抽出します。translate=&quot;no&quot; の trans-unit はスキップします。また、内容が重複すると判断されたものについて抽出を集約します。
     */
    protected boolean fIsFieldGetstateneedstranslationProcessed = false;

    /**
     * [XLIFF対応ツール] 翻訳が必要な trans-unit を抽出します。translate=&quot;no&quot; の trans-unit はスキップします。また、内容が重複すると判断されたものについて抽出を集約します。
     */
    protected boolean fIsFieldGetstatenewProcessed = false;

    /**
     * [XLIFF対応ツール] 翻訳が必要な trans-unit を抽出します。translate=&quot;no&quot; の trans-unit はスキップします。また、内容が重複すると判断されたものについて抽出を集約します。
     */
    protected boolean fIsFieldGettargetnotexistProcessed = false;

    /**
     * verboseモードで動作させるかどうか。
     *
     * @param arg verboseモードで動作させるかどうか。
     */
    public void setVerbose(final boolean arg) {
        fInput.setVerbose(arg);
    }

    /**
     * verboseモードで動作させるかどうか。
     *
     * @return verboseモードで動作させるかどうか。
     */
    public boolean getVerbose() {
        return fInput.getVerbose();
    }

    /**
     * Antタスクの[targetfile]アトリビュートのセッターメソッド。
     *
     * 項目番号: 1<br>
     * 出力対象の XLIFF (*.xlf) ファイル<br>
     *
     * @param arg セットしたい値
     */
    public void setTargetfile(final String arg) {
        fInput.setTargetfile(arg);
        fIsFieldTargetfileProcessed = true;
    }

    /**
     * Antタスクの[targetfile]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 1<br>
     * 出力対象の XLIFF (*.xlf) ファイル<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getTargetfile() {
        return fInput.getTargetfile();
    }

    /**
     * Antタスクの[xliffdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 2<br>
     * 入力対象の XLIFF (*.xlf) ファイルが含まれるディレクトリ。<br>
     *
     * @param arg セットしたい値
     */
    public void setXliffdir(final String arg) {
        fInput.setXliffdir(arg);
        fIsFieldXliffdirProcessed = true;
    }

    /**
     * Antタスクの[xliffdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 2<br>
     * 入力対象の XLIFF (*.xlf) ファイルが含まれるディレクトリ。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getXliffdir() {
        return fInput.getXliffdir();
    }

    /**
     * Antタスクの[getstateneedstranslation]アトリビュートのセッターメソッド。
     *
     * 項目番号: 3<br>
     * state が needs-translation の trans-unit を取得するかどうか。<br>
     *
     * @param arg セットしたい値
     */
    public void setGetstateneedstranslation(final boolean arg) {
        fInput.setGetstateneedstranslation(arg);
        fIsFieldGetstateneedstranslationProcessed = true;
    }

    /**
     * Antタスクの[getstateneedstranslation]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 3<br>
     * state が needs-translation の trans-unit を取得するかどうか。<br>
     * デフォルト値[true]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public boolean getGetstateneedstranslation() {
        return fInput.getGetstateneedstranslation();
    }

    /**
     * Antタスクの[getstatenew]アトリビュートのセッターメソッド。
     *
     * 項目番号: 4<br>
     * state が new の trans-unit を取得するかどうか。<br>
     *
     * @param arg セットしたい値
     */
    public void setGetstatenew(final boolean arg) {
        fInput.setGetstatenew(arg);
        fIsFieldGetstatenewProcessed = true;
    }

    /**
     * Antタスクの[getstatenew]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 4<br>
     * state が new の trans-unit を取得するかどうか。<br>
     * デフォルト値[false]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public boolean getGetstatenew() {
        return fInput.getGetstatenew();
    }

    /**
     * Antタスクの[gettargetnotexist]アトリビュートのセッターメソッド。
     *
     * 項目番号: 5<br>
     * そもそも target が存在しない trans-unit を取得するかどうか。<br>
     *
     * @param arg セットしたい値
     */
    public void setGettargetnotexist(final boolean arg) {
        fInput.setGettargetnotexist(arg);
        fIsFieldGettargetnotexistProcessed = true;
    }

    /**
     * Antタスクの[gettargetnotexist]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 5<br>
     * そもそも target が存在しない trans-unit を取得するかどうか。<br>
     * デフォルト値[false]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public boolean getGettargetnotexist() {
        return fInput.getGettargetnotexist();
    }

    /**
     * Antタスクのメイン処理。Apache Antから このメソッドが呼び出されます。
     *
     * @throws BuildException タスクとしての例外が発生した場合。
     */
    public final void execute() throws BuildException {
        System.out.println("BlancoXliffUtilExtractNeedsTranslationTask begin.");

        // 項目番号[1]、アトリビュート[targetfile]は必須入力です。入力チェックを行います。
        if (fIsFieldTargetfileProcessed == false) {
            throw new BuildException("必須アトリビュート[targetfile]が設定されていません。処理を中断します。");
        }
        // 項目番号[2]、アトリビュート[xliffdir]は必須入力です。入力チェックを行います。
        if (fIsFieldXliffdirProcessed == false) {
            throw new BuildException("必須アトリビュート[xliffdir]が設定されていません。処理を中断します。");
        }

        if (getVerbose()) {
            System.out.println("- verbose:[true]");
            System.out.println("- targetfile:[" + getTargetfile() + "]");
            System.out.println("- xliffdir:[" + getXliffdir() + "]");
            System.out.println("- getstateneedstranslation:[" + getGetstateneedstranslation() + "]");
            System.out.println("- getstatenew:[" + getGetstatenew() + "]");
            System.out.println("- gettargetnotexist:[" + getGettargetnotexist() + "]");
        }

        try {
            // 実際のAntタスクの主処理を実行します。
            // この箇所でコンパイルエラーが発生する場合、BlancoXliffUtilExtractNeedsTranslationProcessインタフェースを実装して blanco.xliff.util.taskパッケージに BlancoXliffUtilExtractNeedsTranslationProcessImplクラスを作成することにより解決できる場合があります。
            final BlancoXliffUtilExtractNeedsTranslationProcess proc = new BlancoXliffUtilExtractNeedsTranslationProcessImpl();
            if (proc.execute(fInput) != BlancoXliffUtilExtractNeedsTranslationBatchProcess.END_SUCCESS) {
                throw new BuildException("タスクは異常終了しました。");
            }
        } catch (IllegalArgumentException e) {
            if (getVerbose()) {
                e.printStackTrace();
            }
            throw new BuildException(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中に例外が発生しました。処理を中断します。" + e.toString());
        } catch (Error e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中にエラーが発生しました。処理を中断します。" + e.toString());
        }
    }
}
